## numpy 1.26.4+ds

=== debian/changelog ===
numpy (1:1.26.4+ds-11build1) oracular; urgency=medium

  * Rebuild against new dpkg without elf-package-metadata.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 07 Aug 2024 15:24:05 +0200

numpy (1:1.26.4+ds-11) unstable; urgency=medium

  * Remove hack to override _add_newdocs_scalars (Closes: #1076899)

 -- Timo Röhling <roehling@debian.org>  Wed, 31 Jul 2024 00:19:32 +0200

numpy (1:1.26.4+ds-10) unstable; urgency=medium

  * Defang upstream gitignore
  * Stop building distutils documentation with Python 3.12 (Closes: #1071255)

 -- Timo Röhling <roehling@debian.org>  Fri, 17 May 2024 18:38:57 +0200

numpy (1:1.26.4+ds-9) unstable; urgency=medium

  * Upload to unstable (Closes: #1070445)
  * More test filtering
  * Fix reproducibility issue with lapack dependency
  * Reorganize patches (no functional changes)
  * Prevent random object file names in debuginfo
  * Skip FPClass tests on mips64el

 -- Timo Röhling <roehling@debian.org>  Thu, 16 May 2024 14:38:07 +0200

numpy (1:1.26.4+ds-9~exp1) experimental; urgency=medium

  [ Michael R. Crusoe ]
  * Bring back the -doc package.

  [ Timo Röhling ]
  * Fix the SWIG documentation patch to reflect recent changes
  * Improve logic to avoid unneeded compilations

 -- Timo Röhling <roehling@debian.org>  Wed, 15 May 2024 21:24:07 +0200

numpy (1:1.26.4+ds-8) unstable; urgency=medium

  * Another round of flaky tests

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Apr 2024 21:52:44 +0200

numpy (1:1.26.4+ds-7) unstable; urgency=medium

  * Make mips64el build more robust
  * Remove outdated READMEs
  * Move packaging helper scripts to dedicated subdir
  * Use deterministic MesonPy build directory
  * Bump Standards-Version to 4.7.0
  * Skip TestErrState::test_invalid on armel (Closes: #1069551)

 -- Timo Röhling <roehling@debian.org>  Thu, 25 Apr 2024 16:10:26 +0200

=== debian/control ===
Source: numpy
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>,
Uploaders:
 Christian Kastner <ckk@debian.org>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 cython3:native (>= 3.0),
 debhelper-compat (= 13),
 dh-python,
 dh-sequence-python3,
 gfortran [amd64 arm64 ppc64el] <!nocheck>,
 libblas-dev [!arm !m68k],
 liblapack-dev [!arm !m68k],
 libpython3-all-dev,
 mypy <!nocheck>,
 ninja-build,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-charset-normalizer <!nocheck>,
 python3-hypothesis <!nocheck>,
 python3-mesonpy:native,
 python3-pyproject-metadata:native,
 python3-pytest <!nocheck>,
 python3-pytest-xdist <!nocheck>,
 python3-scipy <!nocheck>,
 python3-setuptools <!nocheck>,
 python3-typing-extensions (>= 4.2.0) <!nocheck>,
 python3-tz <!nocheck>,
 tzdata-legacy <!nocheck>
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 doxygen <!nodoc>,
 python-imageio-doc <!nodoc>,
 python-pandas-doc <!nodoc>,
 python-pytest-doc <!nodoc>,
 python-scipy-doc <!nodoc>,
 python-skimage-doc <!nodoc>,
 python3-breathe <!nodoc>,
 python3-doc <!nodoc>,
 python3-ipython <!nodoc>,
 python3-matplotlib <!nodoc>,
 python3-numpydoc <!nodoc>,
 python3-pickleshare <!nodoc>,
 python3-pydata-sphinx-theme <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-design <!nodoc>,
# python-matplotlib-doc <!nodoc>,  # missing
Standards-Version: 4.7.0
Vcs-Git: https://salsa.debian.org/python-team/packages/numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/numpy
Homepage: http://www.numpy.org/
Testsuite: autopkgtest-pkg-pybuild
Description: Fast array facility to the Python language
 NumPy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.

Package: python3-numpy
Architecture: any
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
 python3-pkg-resources,
Suggests:
 gcc,
 gfortran,
 python-numpy-doc,
 python3-dev,
 python3-pytest,
Provides:
 dh-sequence-numpy3,
 python3-f2py,
 python3-numpy-dev,
 ${numpy3:Provides},
 ${python3:Provides},
Description: ${source:Synopsis} (Python 3)
 ${source:Extended-Description}
 .
 This package installs NumPy for Python 3.

Package: python-numpy-doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 python-imageio-doc,
 python-pandas-doc,
 python-pytest-doc,
 python-scipy-doc,
 python-skimage-doc,
 python3-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: ${source:Synopsis} (Documentation)
 ${source:Extended-Description}
 .
 This package contains documentation for NumPy and f2py.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# The following tests are problematic and skipped:
# - Meson's python module always returns the default interpreter, which makes
#   Cython related tests fail on non-default python versions
# - numpy.distutils is still shipped because of Python 3.11, which makes the
#   test_all_modules_are_expected test fail with Python 3.12+ (where it is
#   supposed to be dropped).
# - The test for impossible features depends on propagation of /proc/cpuinfo
#   flags and is flaky on buildd (and Ubuntu launchpad).
SKIP_TESTS = \
	cython \
	test_all_modules_are_expected \
	test_impossible_feature_enable

# Some tests have architecture-specific issues. Generally, these are related to
# unexpected behavior of floating point operations (unexpected for the unit
# tests, that is).
ifeq ($(filter amd64 arm64 ppc64el,$(DEB_HOST_ARCH)),)
SKIP_TESTS += f2py
endif
ifneq ($(filter riscv64 armhf armel,$(DEB_HOST_ARCH)),)
SKIP_TESTS += FPClass test_float
endif
ifneq ($(filter armhf armel,$(DEB_HOST_ARCH)),)
SKIP_TESTS += error exception warning fpe overflow \
	SpecialFloats \
	test_divide_err \
	test_empty \
	test_errobj \
	test_features \
	test_invalid \
	test_log2_special \
	test_loss_of_precision \
	test_nonarray_assignment \
	test_special_values \
	test_where \
	test_zero_power_nonzero
endif
ifneq ($(filter mips64el,$(DEB_HOST_ARCH)),)
SKIP_TESTS += error Special test_reduce Nan FPClass
endif
ifneq ($(filter s390x,$(DEB_HOST_ARCH)),)
SKIP_TESTS += test_linear_interpolation_formula_symmetric
endif

export PYBUILD_TEST_CUSTOM = 1
export PYBUILD_TEST_ARGS = {interpreter} {dir}/runtests.py --no-build --verbose --pythonpath {build_dir} \
	-- $(if $(SKIP_TESTS),-k 'not ($(call concat_with,$(space)or$(space),$(SKIP_TESTS)))')
export PYBUILD_BUILD_ARGS = --config-setting build-dir={dir}/.mesonpy

ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
export PYBUILD_BEFORE_BUILD = meson env2mfile --debarch $(DEB_HOST_ARCH) --cross -o {dir}/debian/meson-cross.txt \
	&& python3 {dir}/debian/helpers/add_longdouble_format_property.py {dir}/debian/meson-cross.txt $(DEB_HOST_ARCH)
export PYBUILD_AFTER_BUILD = rm {dir}/debian/meson-cross.txt
PYBUILD_BUILD_ARGS += --config-setting setup-args=--cross-file={dir}/debian/meson-cross.txt
endif

export PYBUILD_DESTDIR = debian/python3-numpy

# Helper variables
PY3VERS = $(shell py3versions -vr)
PY3DEF = $(shell py3versions -vd)
STAGING_DIR = $(CURDIR)/debian/python3-numpy
space = $(eval) $(eval)
concat_with = $(subst $(space),$1,$2)

%:
	dh $@ --buildsystem=pybuild

auto-build-for-default-python:
	PYBUILD_DISABLE="$(filter-out $(PY3DEF),$(PY3VERS))" dh_auto_build
	touch $@

auto-build-for-other-python:
	PYBUILD_DISABLE="$(PY3DEF)" dh_auto_build
	touch $@

override_dh_auto_build-arch: auto-build-for-default-python auto-build-for-other-python
	true

override_dh_auto_build-indep: auto-build-for-default-python
	$(MAKE) -C doc html \
		GITVER=Unknown \
		MPLCONFIGDIR=. \
		PYTHON=python3 \
		PYTHONPATH=$(shell pybuild --print {build_dir} --interpreter python3)

# Nothing to install for -indep
override_dh_auto_install-indep:

# No tests to run for the -doc package
override_dh_auto_test-indep:

override_dh_auto_test-arch:
	dh_auto_test --arch -O--buildsystem=pybuild

execute_after_dh_python3-arch:
	# tweak the entry_points console_scripts list to include all supported versions
	if [ -f $(STAGING_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt ] ; then \
		ENTRYPOINT=$(shell ls $(STAGING_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt) ; \
		python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py3" "numpy.f2py.f2py2e:main" ; \
		for v in $(PY3VERS); do \
			python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py$$v" "numpy.f2py.f2py2e:main" ; \
		done \
	fi
	rm -rf $(STAGING_DIR)/usr/lib/python3.*

execute_before_dh_install-arch:
	# add versioned f2pyX.Y scripts
	cp -a $(STAGING_DIR)/usr/bin/f2py $(STAGING_DIR)/usr/bin/f2py3
	# Create wrappers to run python$$i without dh-python generating a
	# hard dependency on all of those interpreters (#945824)
	set -e; for v in $(PY3VERS); do \
		sed -e "s,@VERSION@,$$v,g" debian/f2py.in > $(STAGING_DIR)/usr/bin/f2py$$v; \
		chmod 0755 $(STAGING_DIR)/usr/bin/f2py$$v; \
	done
	# add numpy.pc backported from NumPy 2.0 (#1067398)
	mkdir -p $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	sed -e  "s,@VERSION@,$(DEB_VERSION_UPSTREAM),g" debian/numpy.pc.in > $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/numpy.pc

execute_before_dh_gencontrol:
	python3 debian/helpers/numpy_substvars.py >> debian/python3-numpy.substvars

download_remote_intersphinx_inventories:
	curl https://matplotlib.org/stable/objects.inv -o debian/intersphinx/matplotlib_objects.inv
	curl https://numpydoc.readthedocs.io/en/latest/objects.inv -o debian/intersphinx/numpydoc_objects.inv
	curl https://numpy.org/neps/objects.inv -o debian/intersphinx/neps_objects.inv
	curl https://numpy.org/numpy-tutorials/objects.inv -o debian/intersphinx/numpy-tutorials_objects.inv
	curl https://dmlc.github.io/dlpack/latest/objects.inv -o debian/intersphinx/dlpack_objects.inv
	curl https://scipy-lectures.org/objects.inv -o debian/intersphinx/scipy-lectures_objects.inv

## numpy 2.2.3+ds

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# PYVER needs to be major.minor, just "3" doesn't work - it will result in
# issues with the amendments to PYTHONPATH and install paths (see DIST_VARS).

# Use explicit "version_info" indexing since make cannot handle colon characters, and
# evaluate it now to allow easier debugging when printing the variable

PYVER:=$(shell python3 -c 'from sys import version_info as v; print("{0}.{1}".format(v[0], v[1]))')
PYTHON = python$(PYVER)

# You can set these variables from the command line.
SPHINXOPTS    ?= -W
SPHINXBUILD   ?= LANG=C sphinx-build
PAPER         ?=
DOXYGEN       ?= doxygen
# For merging a documentation archive into a git checkout of numpy/doc
# Turn a tag like v1.18.0 into 1.18
# Use sed -n -e 's/pattern/match/p' to return a blank value if no match
TAG ?= $(shell git describe --tag | sed -n -e's,v\([1-9]\.[0-9]*\)\.[0-9].*,\1,p')

FILES=

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -T --keep-going -d build/doctrees $(PAPEROPT_$(PAPER)) \
                  $(SPHINXOPTS) source

.PHONY: help clean html web htmlhelp latex changes linkcheck \
	dist dist-build gitwash-update version-check html-build latex-build \
	merge-doc show docenv

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean     to remove generated doc files and start fresh"
	@echo "  docenv    make a virtual environment in which to build docs"
	@echo "  html      to make standalone HTML files"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  dist PYVER=... to make a distribution-ready tree"
	@echo "  gitwash-update GITWASH=path/to/gitwash  update gitwash developer docs"
	@echo "  merge-doc TAG=... to clone numpy/doc and archive documentation into it"
	@echo "  show      to show the html output in a browser"

clean:
	-rm -rf build/*
	find . -name generated -type d -prune -exec rm -rf "{}" ";"

gitwash-update:
	rm -rf source/dev/gitwash
	install -d source/dev/gitwash
	python $(GITWASH)/gitwash_dumper.py source/dev NumPy \
	    --repo-name=numpy \
	    --github-user=numpy
	cat source/dev/gitwash_links.txt >> source/dev/gitwash/git_links.inc

#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current numpy version, and extract docs from it.
# We have to be careful of some issues:
#
# - Everything must be done using the same Python version
#

#SPHINXBUILD="LANG=C sphinx-build"
NUMPYVER:=$(shell $(PYTHON) -c "import numpy; print(numpy.version.git_revision[:7])" 2>/dev/null)
GITVER ?= $(shell (cd ..; set -o pipefail && git rev-parse HEAD 2>/dev/null | cut -c1-7) || echo Unknown)

version-check:
ifeq "$(GITVER)" "Unknown"
	# @echo sdist build with unlabeled sources
else ifeq ("", "$(NUMPYVER)")
	@echo numpy not found, cannot build documentation without successful \"import numpy\"
	@echo Try overriding the makefile PYTHON variable with '"make PYTHON=python $(MAKECMDGOALS)"'
	@exit 1
else ifneq ($(NUMPYVER),$(GITVER))
	@echo installed numpy $(NUMPYVER) != current repo git version \'$(GITVER)\'
	@echo use '"make dist"' or '"GITVER=$(NUMPYVER) make $(MAKECMDGOALS) ..."'
	@exit 1
else
	# for testing
	# @echo installed numpy $(NUMPYVER) matches git version $(GITVER); exit 1
endif


dist: build/dist.tar.gz

build/dist.tar.gz: real-dist

real-dist: html-build
	cp -r build/html build/dist
	cd build/html && zip -9r ../dist/numpy-html.zip .
	cd build/dist && tar czf ../dist.tar.gz *
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s

merge-doc: build/dist.tar.gz
ifeq "$(TAG)" ""
	echo tag "$(TAG)" not of the form 1.18;
	exit 1;
endif
	@# Only clone if the directory does not exist
	@if ! test -d build/merge; then \
		git clone https://github.com/numpy/doc build/merge; \
	fi;
	@# Remove any old content and copy in the new, add it to git
	-rm -rf build/merge/$(TAG)/*
	-mkdir -p build/merge/$(TAG)
	@# -C changes working directory
	tar -C build/merge/$(TAG) -xf build/dist.tar.gz
	git -C build/merge add $(TAG)
	@# For now, the user must do this. If it is onerous, automate it and change
	@# the instructions in doc/RELEASE_WALKTHROUGH.rst
	@echo " "
	@echo New documentation archive added to ./build/merge.
	@echo Now add/modify the appropriate section after
	@echo "    <!-- insert here -->"
	@echo in build/merge/index.html,
	@echo change _static/versions.json,
	@echo and run \"python3 update.py\"
	@echo then \"git commit\", \"git push\"


#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

generate: build/generate-stamp
build/generate-stamp: $(wildcard source/reference/*.rst)
	mkdir -p build
	touch build/generate-stamp

html: version-check html-build
html-build: generate
	mkdir -p build/html build/doctrees
	$(PYTHON) preprocess.py
ifeq (, $(shell which $(DOXYGEN)))
	@echo "Unable to find 'Doxygen:$(DOXYGEN)', skip generating C/C++ API from comment blocks."
else
	$(DOXYGEN) build/doxygen/Doxyfile
endif
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) build/html $(FILES)
	$(PYTHON) postprocess.py html build/html/*.html
	@echo
	@echo "Build finished. The HTML pages are in build/html."

htmlhelp: generate version-check
	mkdir -p build/htmlhelp build/doctrees
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) build/htmlhelp $(FILES)
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in build/htmlhelp."

htmlhelp-build: htmlhelp build/htmlhelp/numpy.chm
%.chm: %.hhp
	-hhc.exe $^

qthelp: generate version-check
	mkdir -p build/qthelp build/doctrees
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) build/qthelp $(FILES)

latex: version-check latex-build
latex-build: generate
	mkdir -p build/latex build/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex $(FILES)
	$(PYTHON) postprocess.py tex build/latex/*.tex
	perl -pi -e 's/LATEXOPTS =/LATEXOPTS ?= --halt-on-error/' build/latex/Makefile
	@echo
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

coverage: build version-check
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: generate version-check
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: generate version-check
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in build/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C build/texinfo info
	@echo "makeinfo finished; the Info files are in build/texinfo."


show:
	@python -c "import webbrowser; webbrowser.open_new_tab('file://$(PWD)/build/html/index.html')"

=== vendored-meson/meson/test cases/cmake/27 dependency fallback/subprojects/cmake_subp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(cmModDummy)

=== debian/changelog ===
numpy (1:2.2.3+ds-2) unstable; urgency=medium

  * Bump Standards-Version to 4.7.1
  * Properly execute dir_to_symlink transition (Closes: #1098365)

 -- Timo Röhling <roehling@debian.org>  Thu, 20 Feb 2025 11:56:23 +0100

numpy (1:2.2.3+ds-1) unstable; urgency=medium

  * New upstream version 2.2.3+ds (Closes: #1095468)
  * Skip huge_vectordot test on all 32 bit architectures (Closes: #1097126)

 -- Timo Röhling <roehling@debian.org>  Tue, 18 Feb 2025 09:52:55 +0100

numpy (1:2.2.2+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 26 Jan 2025 21:02:29 +0100

numpy (1:2.2.2+ds-1) experimental; urgency=medium

  * New upstream version 2.2.2+ds

 -- Timo Röhling <roehling@debian.org>  Mon, 20 Jan 2025 18:07:13 +0100

numpy (1:2.2.1+ds-2) experimental; urgency=medium

  [ Alexandre Detiste ]
  * Fix syntax error in Maintainer: field that confuses UDD & the Tracker

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Jan 2025 12:02:00 +0100

numpy (1:2.2.1+ds-1) experimental; urgency=medium

  * New upstream version 2.2.1+ds
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Jan 2025 11:28:28 +0100

numpy (1:2.2.0+ds-1) experimental; urgency=medium

  * New upstream version 2.2.0+ds
  * Update patches
    - Drop 0009-Use-correct-Python-interpreter-in-tests.patch
      (merged upstream)
  * Wrap and sort Debian package files
  * Drop dependency on python3-pkg-resources (Closes: #1083512)

 -- Timo Röhling <roehling@debian.org>  Thu, 12 Dec 2024 23:47:03 +0100

numpy (1:2.1.3+ds-2) experimental; urgency=medium

  * Skip failing autopkgtest after scrubbing __config__.py

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Dec 2024 00:05:44 +0100

numpy (1:2.1.3+ds-1) experimental; urgency=medium

  * New upstream version 2.1.3+ds
  * Move dh_numpy3 to python3-numpy-dev
  * Fix __config__.py divergence between different Python versions
  * Finalize package layout for better cross-build support
    (Closes: #1076236)

 -- Timo Röhling <roehling@debian.org>  Sat, 23 Nov 2024 00:37:09 +0100

numpy (1:2.1.2+ds-1) experimental; urgency=medium

  [ Dima Kogan ]
  * swig numpy docs contain the correct include path

  [ Timo Röhling ]
  * Skip test that fills up Salsa autopkgtest filesystem
  * New upstream version 2.1.2+ds

 -- Timo Röhling <roehling@debian.org>  Tue, 08 Oct 2024 18:55:28 +0200

numpy (1:2.1.1+ds-3) experimental; urgency=medium

  * Make __config__.py reproducible
  * Use correct Python interpreter in tests (Closes: #1082094)

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Sep 2024 23:45:59 +0200

numpy (1:2.1.1+ds-2) experimental; urgency=medium

  * Use sysconfig module and _PYTHON_SYSCONFIGDATA_NAME for cross build support
  * Skip a few more problematic tests

 -- Timo Röhling <roehling@debian.org>  Mon, 16 Sep 2024 23:41:43 +0200

numpy (1:2.1.1+ds-1) experimental; urgency=medium

  * New upstream version 2.1.1+ds
  * Add missing test excludes for arch-specific fails
  * Split python3-numpy-dev off python3-numpy for better cross-build support
  * Improve package description
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Fri, 06 Sep 2024 14:18:38 +0200

numpy (1:2.1.0+ds-2) experimental; urgency=medium

  * Ignore arch-specific test failures

 -- Timo Röhling <roehling@debian.org>  Mon, 02 Sep 2024 00:08:35 +0200

numpy (1:2.1.0+ds-1) experimental; urgency=medium

  * New upstream version 2.1.0+ds
  * Update copyright information
  * Update patches
    - Drop Do-not-fail-if-we-cannot-import-mingw32.patch (obsolete)
    - Drop Use-proper-lapack-dependency-for-__config__.py.patch (merged)
    - Drop Do-not-fail-the-build-on-Sphinx-warnings.patch (obsolete)
    - Drop Prevent-random-object-file-names-in-debuginfo.patch (merged)
    - Drop Ignore-distutils-for-Python-3.12-and-later.patch (obsolete)
    - Drop Remove-hack-to-override-_add_newdocs_scalars.patch (obsolete)
  * Update NumPy ABI/API versioning
  * Update prefix path in debian/numpy.pc
  * Update test suite invocation
  * Prepare multi-arch support for numpy.pc
  * Avoid circular NumPy build dependencies
  * New required Sphinx extension copybutton
  * Relax api-min-version requirement in dh_numpy3

 -- Timo Röhling <roehling@debian.org>  Fri, 30 Aug 2024 18:11:32 +0200

numpy (1:1.26.4+ds-13) unstable; urgency=medium

  * Team upload.
  * Remove dependency on python3-pkg-resources (Closes: #1083512)

 -- Alexandre Detiste <tchet@debian.org>  Mon, 13 Jan 2025 20:42:00 +0100

numpy (1:1.26.4+ds-12) unstable; urgency=medium

  * Team upload.
  * Patch test_iter_refcount to support Python 3.13.
  * Skip test_deprecate_* to support Python 3.13.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 14 Nov 2024 14:43:59 +0100

=== debian/control ===
Source: numpy
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Christian Kastner <ckk@debian.org>,
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 cython3:native (>= 3.0),
 gfortran [amd64 arm64 ppc64el] <!nocheck>,
 libblas-dev [!arm !m68k],
 liblapack-dev [!arm !m68k],
 libpython3-all-dev,
 mypy <!nocheck>,
 ninja-build,
 pkgconf <!nocheck>,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-charset-normalizer <!nocheck>,
 python3-hypothesis <!nocheck>,
 python3-mesonpy:native,
 python3-pyproject-metadata:native,
 python3-pytest <!nocheck>,
 python3-pytest-xdist <!nocheck>,
 python3-setuptools <!nocheck>,
 python3-typing-extensions (>= 4.2.0) <!nocheck>,
 python3-tz <!nocheck>,
 tzdata-legacy <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 doxygen <!nodoc>,
 python-imageio-doc <!nodoc>,
 python-pandas-doc <!nodoc>,
 python-pytest-doc <!nodoc>,
 python-scipy-doc <!nodoc>,
 python-skimage-doc <!nodoc>,
 python3-breathe <!nodoc>,
 python3-doc <!nodoc>,
 python3-ipython <!nodoc>,
 python3-numpydoc <!nodoc>,
 python3-pickleshare <!nodoc>,
 python3-pydata-sphinx-theme <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-copybutton <!nodoc>,
 python3-sphinx-design <!nodoc>,
# python-matplotlib-doc <!nodoc>,  # missing
Standards-Version: 4.7.1
Vcs-Git: https://salsa.debian.org/python-team/packages/numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/numpy
Homepage: http://www.numpy.org/
Testsuite: autopkgtest-pkg-pybuild
Description: Python library for numerical computations
 NumPy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.

Package: python3-numpy
Architecture: any
Multi-Arch: allowed
Pre-Depends:
 dpkg (>= 1.17.14),
Depends:
 python3-numpy-dev (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Suggests:
 gcc,
 gfortran,
 python-numpy-doc,
 python3-dev,
 python3-pytest,
Provides:
 python3-f2py,
 ${numpy3:Provides},
 ${python3:Provides},
Description: ${source:Synopsis} (Python 3)
 ${source:Extended-Description}
 .
 This package installs NumPy for Python 3.

Package: python-numpy-doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Suggests:
 python-imageio-doc,
 python-pandas-doc,
 python-pytest-doc,
 python-scipy-doc,
 python-skimage-doc,
 python3-doc,
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Description: ${source:Synopsis} (Documentation)
 ${source:Extended-Description}
 .
 This package contains documentation for NumPy and f2py.

Package: python3-numpy-dev
Architecture: any
Multi-Arch: same
Breaks:
 python3-numpy (<< 1:2.1.3+ds-1~),
Replaces:
 python3-numpy (<< 1:2.1.3+ds-1~),
Depends:
 ${misc:Depends},
Recommends:
 python3-numpy,
Provides:
 dh-sequence-numpy3,
Description: ${source:Synopsis} (Python 3 headers)
 ${source:Extended-Description}
 .
 This package installs the development headers which are needed
 to build C/C++ extensions with NumPy for Python 3.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

# Large file support actually works, but some buildds and Salsa do not like us
# creating 5 GB files.
SKIP_TESTS = \
	test_big_arrays \
	test_large_file_support
# Some tests have architecture-specific issues. Generally, these are related to
# unexpected behavior of floating point operations (unexpected for the unit
# tests, that is).
ifneq ($(filter armel armhf,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	FPClass \
	SpecialFloats \
	TestBoolCmp \
	error \
	except \
	overflow \
	test_denormal_numbers \
	test_divide_err \
	test_empty \
	test_exotic \
	test_features \
	test_half_fpe \
	test_linear_interpolation_formula_symmetric \
	test_log2_special \
	test_nonarray_assignment \
	test_special_values \
	test_where \
	test_zero_power_nonzero
endif
# The huge vector exceeds the available address space on 32 bit architectures
ifeq ($(DEB_HOST_ARCH_BITS),32)
SKIP_TESTS += \
	test_huge_vectordot
endif
ifneq ($(filter mips64el,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	NanFunctions \
	SpecialComplex \
	SpecialFloats \
	error \
	test_reduce
endif
ifneq ($(filter mips64el powerpc ppc64 sparc64,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	sq_cases
endif
ifneq ($(filter hppa powerpc,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	ctypeslib \
	test_dtype
endif
ifneq ($(filter powerpc,$(DEB_HOST_ARCH)),)
SKIP_TESTS += \
	test_linalg
endif
ifeq ($(PYBUILD_AUTOPKGTEST),1)
SKIP_TESTS += test_dict_mode
endif

export PYBUILD_BUILD_ARGS = --config-setting build-dir={dir}/.mesonpy
export PYBUILD_TEST_ARGS = $(if $(SKIP_TESTS),-k 'not ($(call concat_with,$(space)or$(space),$(SKIP_TESTS)))')
ifeq ($(PYBUILD_AUTOPKGTEST),1)
PYBUILD_TEST_ARGS += /usr/lib/python3/dist-packages/numpy
endif

ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
export PYBUILD_BEFORE_BUILD = meson env2mfile --debarch $(DEB_HOST_ARCH) --cross -o {dir}/debian/meson-cross.txt \
	&& python3 {dir}/debian/helpers/add_longdouble_format_property.py {dir}/debian/meson-cross.txt $(DEB_HOST_ARCH)
export PYBUILD_AFTER_BUILD = rm {dir}/debian/meson-cross.txt
PYBUILD_BUILD_ARGS += --config-setting setup-args=--cross-file={dir}/debian/meson-cross.txt
endif

# Helper variables
PY3VERS = $(shell py3versions -vr)
PY3DEF = $(shell py3versions -vd)
STAGING_DIR = $(CURDIR)/debian/tmp
PYTHON3_NUMPY_DIR = $(CURDIR)/debian/python3-numpy
space = $(eval) $(eval)
concat_with = $(subst $(space),$1,$2)

%:
	dh $@ --buildsystem=pybuild

auto-build-for-default-python:
	PYBUILD_DISABLE="$(filter-out $(PY3DEF),$(PY3VERS))" dh_auto_build
	touch $@

auto-build-for-other-python:
	PYBUILD_DISABLE="$(PY3DEF)" dh_auto_build
	touch $@

override_dh_auto_build-arch: auto-build-for-default-python auto-build-for-other-python
	true

override_dh_auto_build-indep: auto-build-for-default-python
	$(MAKE) -C doc html \
		GITVER=Unknown \
		MPLCONFIGDIR=. \
		SPHINXOPTS= \
		PYTHON=python3 \
		PYTHONPATH=$(shell pybuild --print {build_dir} --interpreter python3)

# Nothing to install for -indep
override_dh_auto_install-indep:

# No tests to run for the -doc package
override_dh_auto_test-indep:

override_dh_auto_test-arch:
	dh_auto_test --arch -O--buildsystem=pybuild

execute_after_dh_python3-arch:
	# tweak the entry_points console_scripts list to include all supported versions
	if [ -f $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt ] ; then \
		ENTRYPOINT=$(shell ls $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/numpy-*.dist-info/entry_points.txt) ; \
		python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py3" "numpy.f2py.f2py2e:main" ; \
		for v in $(PY3VERS); do \
			python3 debian/helpers/edit_console_scripts.py $$ENTRYPOINT "f2py$$v" "numpy.f2py.f2py2e:main" ; \
		done \
	fi
	# Remove test artifact
	rm -f $(PYTHON3_NUMPY_DIR)/usr/lib/python3/dist-packages/xm.np.npy

MULTIARCH_TREE_DIR = $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/python3-numpy/numpy
execute_before_dh_install-arch:
	# add versioned f2pyX.Y scripts
	cp -a $(STAGING_DIR)/usr/bin/f2py $(STAGING_DIR)/usr/bin/f2py3
	# Create wrappers to run python$$i without dh-python generating a
	# hard dependency on all of those interpreters (#945824)
	set -e; for v in $(PY3VERS); do \
		sed -e "s,@VERSION@,$$v,g" debian/f2py.in > $(STAGING_DIR)/usr/bin/f2py$$v; \
		chmod 0755 $(STAGING_DIR)/usr/bin/f2py$$v; \
	done
	# Remove various LICENSE files from inconvienient locations
	find $(STAGING_DIR)/usr/lib -name "LICENSE*" -delete
	# Move NumPy headers to Multi-Arch friendly location
	mkdir -p $(MULTIARCH_TREE_DIR)/_core $(MULTIARCH_TREE_DIR)/random $(MULTIARCH_TREE_DIR)/f2py
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/_core/include $(MULTIARCH_TREE_DIR)/_core
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/_core/lib $(MULTIARCH_TREE_DIR)/_core
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/random/lib $(MULTIARCH_TREE_DIR)/random
	mv $(STAGING_DIR)/usr/lib/python$(PY3DEF)/dist-packages/numpy/f2py/src $(MULTIARCH_TREE_DIR)/f2py
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/_core/include
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/_core/lib
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/random/lib
	rm -rf $(STAGING_DIR)/usr/lib/python3.*/dist-packages/numpy/f2py/src
	# Remove build path from __config__.py
	sed -i -e "s;$(CURDIR);\$$BUILDDIR;g" $(STAGING_DIR)/usr/lib/python3*/dist-packages/numpy/__config__.py
	# Remove Python version information from __config__.py
	sed -i -e '/"Python Information": {/,/},/d' $(STAGING_DIR)/usr/lib/python3*/dist-packages/numpy/__config__.py
	# Install numpy.pc for global discovery (without numpy-config shenanigans)
	mkdir -p $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	sed \
		-e "s,@VERSION@,$(shell echo $(DEB_VERSION_UPSTREAM) | cut -d+ -f1),g" \
		-e "s,@MULTIARCH@,$(DEB_HOST_MULTIARCH),g" \
		debian/numpy.pc.in > $(STAGING_DIR)/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/numpy.pc

execute_before_dh_gencontrol:
	python3 debian/helpers/numpy_substvars.py >> debian/python3-numpy.substvars

download_remote_intersphinx_inventories:
	curl https://matplotlib.org/stable/objects.inv -o debian/intersphinx/matplotlib_objects.inv
	curl https://numpydoc.readthedocs.io/en/latest/objects.inv -o debian/intersphinx/numpydoc_objects.inv
	curl https://numpy.org/neps/objects.inv -o debian/intersphinx/neps_objects.inv
	curl https://numpy.org/numpy-tutorials/objects.inv -o debian/intersphinx/numpy-tutorials_objects.inv
	curl https://dmlc.github.io/dlpack/latest/objects.inv -o debian/intersphinx/dlpack_objects.inv
	curl https://scipy-lectures.org/objects.inv -o debian/intersphinx/scipy-lectures_objects.inv

## numpy 2.2.4%2Bds

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,7 @@
 	error \
 	test_reduce
 endif
-ifneq ($(filter mips64el powerpc ppc64 sparc64,$(DEB_HOST_ARCH)),)
+ifneq ($(filter alpha mips64el powerpc ppc64 sparc64,$(DEB_HOST_ARCH)),)
 SKIP_TESTS += \
 	sq_cases
 endif
@@ -57,6 +57,11 @@
 ifneq ($(filter powerpc,$(DEB_HOST_ARCH)),)
 SKIP_TESTS += \
 	test_linalg
+endif
+ifneq ($(filter ppc64el,$(DEB_HOST_ARCH)),)
+SKIP_TESTS += \
+	test_ppc64_ibm_double_double128 \
+	test_linear_interpolation_formula_symmetric
 endif
 ifeq ($(PYBUILD_AUTOPKGTEST),1)
 SKIP_TESTS += test_dict_mode

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)v?@ANY_VERSION@.tar.gz%@PACKAGE@-$1.tar.gz%,\
 dversionmangle=auto,oversionmangle=s%$%+ds%,repack \
 https://api.github.com/repos/numpy/numpy/releases \
 https://github.com/numpy/numpy/releases/download/v\d[\.\d]*/numpy-@ANY_VERSION@@ARCHIVE_EXT@
